--[[
	Creator: AelitePrime 
	Script Name: Blocking Script
	Website: http://phasorscripts.wordpress.com/
	Xfire: eliteprime14789x
	Version: 2.0
	
	Reason for Update:
		- Phasor Update
		- Added Command

]]--

--[[ Modify ]] --
warning_message = "You cannot stand here."
kill_message = "I told you..."
warning_time = 5 -- in seconds
kill_time = 10 -- in seconds

-- [[ Do not Modify]] --
info = {}
block_list = {}

function GetRequiredVersion()
	return 200
end

function OnScriptLoad(process, game, persistent)
	profilepath = getprofilepath()
	local file = io.open(profilepath .. "\\data\\blocklist.data", "r")
	if file then
		for line in file:lines() do
			local word = tokenizestring(line, ",")
			block_list[word[1]] = {word[2],tonumber(word[3]),tonumber(word[4]),tonumber(word[5]),tonumber(word[6]),tonumber(word[7])}
		end
		file:close()
	end
	for i=0,15 do
		info[i] = {}
		info[i].count = 0
		info[i].boolean = true
	end
	if game == "PC" or game == true then
		Map = readstring(0x698F21)
	else
		Map = readstring(0x61D151)
	end
	timer = registertimer(1000, "countdown")
end

function OnScriptUnload()
	local file = io.open(profilepath .. "\\data\\blocklist.data", "w")
	for i,j in pairs(block_list) do
		if block_list[i] then
			file:write( i .. "," .. block_list[i][1] .. "," .. block_list[i][2] .. "," .. block_list[i][3] .. "," .. block_list[i][4]  .. "," ..  block_list[i][4] .. "," .. block_list[i][6])
		end
	end
end

function OnGameEnd(stage)
	if mode == 1 then
		if timer then
			removetimer(timer)
		end
	end
end

function OnServerCommand(player, command)
	local response = nil
	local t = tokenizecmdstring(command)
	local count = #t
	if t[1] == "sv_addblock" then
		response = false
		Command_AddBlock(player, t[1], t[2], t[3], t[4], count)
	elseif t[1] == "sv_delblock" then
		response = false
		Command_DelBlock(player, t[1], t[2], count)
	elseif t[1] == "sv_blockedlist" then
		response = false
		Command_BlockedList(player, t[1], count)
	end
	return response
end

function OnPlayerJoin(player)
	info[player].count = 0
	info[player].boolean = true
end

function OnPlayerSpawn(player)
	info[player].count = 0
	info[player].boolean = true
end

function OnPlayerKill(killer, victim, mode)
	info[victim].boolean = true
end

function OnClientUpdate(player)
	local m_objectId = getplayerobjectid(player)
	if m_objectId == nil then
		return
	end
	local not_in_a_sphere = true
	for i,j in pairs(block_list) do
		if block_list[i] then
			if block_list[i][1] == Map then
				Radius = tonumber(block_list[i][6]) or 2.5
				if sphere(m_objectId, block_list[i][2], block_list[i][3], block_list[i][4], Radius) then
					if block_list[i][5] == -1 then
						not_in_a_sphere = false
					else
						local team = getteam(player)
						if team == block_list[i][5] then
							not_in_a_sphere = false
						end
					end
				end
			end
		end
	end
	info[player].boolean = not_in_a_sphere
end

function Command_AddBlock(executor, command, name, team, radius, count)
	if count >= 2 and count <= 4 and executor ~= nil then
		if tostring(name) then
			team = string.lower(team) or "both"
			if team == "red" or team == "blue" or team == "both" then
				radius = tonumber(radius) or 2.5
				local m_objectId = getplayerobjectid(executor)
				if m_objectId then
					local x,y,z = getobjectcoords(m_objectId)
					if team == "red" then
						ateam = 0
					elseif team == "blue" then
						ateam = 1
					else
						ateam = -1
					end
					block_list[tostring(name)] = {Map,x,y,z,ateam,radius}
					sendresponse("Blocked Area Created: [ X: " .. round(x, 2) .. " Y: " .. round(z, 2) .. " Z: " .. round(z, 2) .. "]\nRadius: " .. radius .. "\nMap: " .. Map.."\nTeam: " .. team, command, executor)
				else
					sendresponse("You must be alive to execute this command", command, executor)
				end
			else
				sendresponse("Invalid Team! Options: 'red', 'blue', or 'both'", command, executor)
			end
		else
			sendresponse("Invalid Name", command, executor)
		end
	elseif executor == nil then
		sendresponse("You cannot execute this command from the console!", command, executor)
	else	
		sendresponse("Invalid Syntax: " .. command .. " [name] [team] {radius}", command, executor)
	end
end

function Command_DelBlock(executor, command, ID, count)
	if count == 2 then
			if block_list[ID] then
				block_list[ID] = nil
				sendresponse("ID: " .. ID .. "  has been removed", command, executor)
			else
				sendresponse("Invalid ID", command, executor)
			end
	else
		sendresponse("Invalid Syntax: " .. command .. " [ID]", command, executor)
	end
end

function Command_BlockedList(executor, command, count)
	if count == 1 then
		local response = ""
		for i,j in pairs(block_list) do
			if block_list[i] then
				if block_list[i][1] == Map then
					if block_list[i][5] == -1 then
						team = "both"
					elseif block_list[i][5] == 0 then
						team = "red"
					elseif block_list[i][5] == 1 then
						team = "blue"
					else
						team = "error"
					end
					response = response .. "ID: " .. i .. "\n       -- X: " .. round(block_list[i][2],2) .. "  Y: " .. round(block_list[i][3],2) .. "  Z: " .. round(block_list[i][4],2) .. "\n       -- Team: " .. team .. "  Radius: " .. block_list[i][6] .. "\n"
				end
			end
		end
		sendresponse(response, command, executor)
	else
		sendresponse("Invalid Syntax: " .. command, command, executor)
	end
end

function countdown(id, count)
	for i=0,15 do
		if getplayer(i) then
			if info[i].boolean then
				if info[i].count > 0 then
					info[i].count = info[i].count - 1
				end
			else
				info[i].count = info[i].count + 1
				if info[i].count == kill_time then
					privatesay(i, kill_message)
					kill(i)
				elseif info[i].count == warning_time then
					privatesay(i, warning_message)
				end
			end
		end
	end
	return true
end

function round(val, decimal)
	if (decimal) then
		return math.floor((val * 10^decimal) + 0.5) / (10^decimal)
	else
		return math.floor(val+0.5)
	end
end

function sendresponse(message, command, player)
	player = tonumber(player)
	if tonumber(player) and player ~= nil and player ~= -1 and player >= 0 and player < 16 then
		sendconsoletext(player, message)
	else
		hprintf(message)
	end
end

function sphere(m_objectId, X, Y, Z, R)
	local Pass = false
	if getobject(m_objectId) then
		local x,y,z = getobjectcoords(m_objectId)
		if (X - x)^2 + (Y - y)^2 + (Z - z)^2 <= R then
            Pass = true
        end
    end
    return Pass
end
