--[[ ### Death-Kill Messages ###]]--
--[[ ###     by H® Shaft     ###]]-- 
--[[ ###    for Phasor v2    ###]]--
--[[ ###  other thanks below ###]]--

last_damage = {} 

function GetRequiredVersion()
	return 200
end

function OnScriptLoad(process, game, persistent)
	GAME = game
end

function OnScriptUnload()

end

function OnNewGame(map)

	if GAME == "PC" then
		gametype_base = 0x671340
	elseif GAME == "CE" then
		gametype_base = 0x5F5498
	end
	
	last_damage = {}
end	

 -- Thanks to Elite Prime for this
function OnDamageApplication(receiving, causing, tagid, hit, backtap)
	if receiving then
		local r_object = getobject(receiving)
		if r_object then
			local receiver = objectaddrtoplayer(r_object)
			if receiver then
				if not backtap then
					local r_hash = gethash(receiver)
					local tagname,tagtype = gettaginfo(tagid)
					last_damage[r_hash] = tagname
				else
					last_damage[r_hash] = "backtap"
				end
			end
		end
	end
end
			
function OnPlayerKill(killer, victim, mode)
	
	if mode == 0 then
		local v_name = getname(victim)
		local vhash = gethash(victim)
		say(v_name .. " was killed by the server. ")
		
	elseif mode == 1 then -- player was killed by falling
		local v_name = getname(victim)
		local vhash = gethash(victim)
		say(v_name .. " fell to their death. ")
		
	elseif mode == 2 then -- player was killed by the guardians
		local v_name = getname(victim)
		local vhash = gethash(victim)
		say(v_name .. " was killed by the guardians. ")
	elseif mode == 3 then -- player was killed by vehicle
		local v_name = getname(victim)
		local vhash = gethash(victim)
		say(v_name .. " was killed by a vehicle. ")	
		
	elseif mode == 4 then -- player was killed by another player
		local v_name = getname(victim)
		local vhash = gethash(victim)
		
		if last_damage[vhash] then
			local khash = gethash(killer)
			local k_name = getname(killer)
			
			if string.find(last_damage[vhash], "melee") then			
				say(k_name .. " smacked " .. v_name .. " upside the head! ")					
			elseif last_damage[vhash] == "globals\\distance" or last_damage[vhash] == "globals\\falling" then
				say(v_name .. " fell to their death. ")
			elseif last_damage[vhash] == "globals\\vehicle_collision" then
				say(k_name .. " ran over " .. v_name) 					
			elseif string.find(last_damage[vhash], "banshee") then
				say(k_name .. " killed " .. v_name .. " with a banshee. ")
			elseif last_damage[vhash] == "vehicles\\c gun turret\\mp bolt" then
				say(k_name .. " killed " .. v_name .. " with the covenant turret. ")
			elseif last_damage[vhash] == "vehicles\\ghost\\ghost bolt" then
				say(k_name .. " killed " .. v_name .. " with the ghost plasma guns. ")
			elseif last_damage[vhash] == "vehicles\\scorpion\\bullet" then
				say(k_name .. " killed " .. v_name .. " with the scorpion guns. ")
			elseif last_damage[vhash] == "vehicles\\scorpion\\shell explosion" then
				say(k_name .. " killed " .. v_name .. " with the scorpion cannon. ")
			elseif last_damage[vhash] == "vehicles\\warthog\\bullet" then
				say(k_name .. " killed " .. v_name .. " with a warthog chain-gun. ")
			elseif last_damage[vhash] == "weapons\\assault rifle\\bullet" then
				say(k_name .. " killed " .. v_name .. " with an assault rifle. ")			
			elseif last_damage[vhash] == "weapons\\flamethrower\\burning" or last_damage[vhash] == "weapons\\flamethrower\\explosion" or last_damage[vhash] == "weapons\\flamethrower\\impact damage" then
				say(k_name .. " killed " .. v_name .. " with a flame-thrower. ")
			elseif last_damage[vhash] == "weapons\\frag grenade\\explosion" then
				say(k_name .. " killed " .. v_name .. " with a frag grenade. ")					
			elseif last_damage[vhash] == "weapons\\needler\\detonation damage" or last_damage[vhash] == "weapons\\needler\\explosion" or last_damage[vhash] == "weapons\\needler\\impact damage" then
				say(k_name .. " killed " .. v_name .. " with a needler. ")					
			elseif last_damage[vhash] == "weapons\\pistol\\bullet" then
				say(k_name .. " killed " .. v_name .. " with a pistol. ")	
			elseif last_damage[vhash] == "weapons\\plasma grenade\\attached" or last_damage[vhash] == "weapons\\plasma grenade\\explosion" then
				say(k_name .. " killed " .. v_name .. " with a plasma grenade. ")
			elseif last_damage[vhash] == "weapons\\plasma pistol\\bolt" or last_damage[vhash] == "weapons\\plasma rifle\\charged bolt" then
				say(k_name .. " killed " .. v_name .. " with a plasma pistol. ")
			elseif last_damage[vhash] == "weapons\\plasma rifle\\bolt" then
				say(k_name .. " killed " .. v_name .. " with a plasma rifle. ")	
			elseif last_damage[vhash] == "weapons\\plasma_cannon\\effects\\plasma_cannon_explosion" or last_damage[vhash] == "weapons\\plasma_cannon\\impact damage" then
				say(k_name .. " killed " .. v_name .. " with a fuel-rod gun. ")	
			elseif last_damage[vhash] == "weapons\\rocket launcher\\explosion" then
				say(k_name .. " killed " .. v_name .. " with a rocket launcher. ")
			elseif last_damage[vhash] == "weapons\\shotgun\\pellet" then
				say(k_name .. " killed " .. v_name .. " with a shot gun. ")	
			elseif last_damage[vhash] == "weapons\\sniper rifle\\sniper bullet" then
				say(k_name .. " killed " .. v_name .. " with a sniper rifle. ")
			end
		end

	elseif mode == 5 then -- player was killed by teammate
		local v_name = getname(victim)
		local vhash = gethash(victim)
		local khash = gethash(killer)
		local k_name = getname(killer)
		-- announcement not needed
		
	elseif mode == 6 then --suicides
		local v_name = getname(victim)
		local vhash = gethash(victim)
		-- announcement not needed	
		
	end
	
end	
 
-- Thanks to H® BugZ, Oxide, Elite Prime, Nugget & Wizard & many others for their contributions to Phasor and the Halo Community, Special Thanks to Elite Prime for added assistance.