--[[ ###    Rock-The-Vote    ###]]--
--[[ ###     by H® Shaft     ###]]-- 
--[[ ###    for Phasor v2    ###]]--
--[[ ###  other thanks below ###]]--

rtv_required = 0.6 	-- % of players or more will allow skipping the current map

-- don't edit --
cur_players = 0
rtv_table = {}
rtv_timeout = 1
rtv_initiated = -1
rockthevote = false
	
function GetRequiredVersion()
	return 200
end
 
function OnScriptLoad(processId, game, persistent)
	GAME = game
end

function OnNewGame(map)

	if GAME == "PC" then
		gametype_base = 0x671340
		map_name = readstring(0x698F21)
	elseif GAME == "CE" then
		gametype_base = 0x5F5498
		map_name = readstring(0x61D151)
	end
	
	rtv_initiated = 0
	rtv_table = {}
	
	-- ========== Start enable-disable Rock-The-Vote per map ============
	-- to disable rtv for a specific map, change 'true' to 'false'
	if map_name == "bloodgulch" then
		rockthevote = true
	elseif map_name == "dangercanyon" then
		rockthevote = true
	elseif map_name == "deathisland" then
		rockthevote = true
	elseif map_name == "gephyrophobia" then
		rockthevote = true
	elseif map_name == "icefields" then
		rockthevote = true
	elseif map_name == "infinity" then
		rockthevote = true
	elseif map_name == "sidewinder" then
		rockthevote = true
	elseif map_name == "timberland" then
		rockthevote = true
	elseif map_name == "beavercreek" then -- battle creek
		rockthevote = true
	elseif map_name == "boardingaction" then
		rockthevote = true
	elseif map_name == "carousel" then  -- derelict
		rockthevote = true
	elseif map_name == "chillout" then
		rockthevote = true
	elseif map_name == "damnation" then
		rockthevote = true
	elseif map_name == "hangemhigh" then
		rockthevote = true
	elseif map_name == "longest" then
		rockthevote = true
	elseif map_name == "prisoner" then
		rockthevote = true
	elseif map_name == "putput" then -- chiron tl34
		rockthevote = true
	elseif map_name == "ratrace" then
		rockthevote = true
	elseif map_name == "wizard" then
		rockthevote = true
	--Note, to add a CE map, add map name here in quotes, and remove the -- in front of elseif and rockthevote as shown above, add an entry for each map:		
	--elseif map_name == "CE-MAP-NAME-HERE" then
	--	rockthevote = true			
	end
	-- ========== End enable-disable Rock-The-Vote per map ============	
end

function OnGameEnd(stage)
	if stage == 1 then
		if rtvtimer then 
			removetimer(rtvtimer)
			rtvtimer = nil
		end
		rtv_initiated = -1 
	end	
end

function OnPlayerJoin(player)
	cur_players = cur_players + 1	
end

function OnPlayerLeave(player)
	cur_players = cur_players - 1 
end

function OnServerChat(player, type, message)
	if player then
		name = getname(player)
		hash = gethash(player)
	end
	
	local t = tokenizestring(message, " ")
	local count = #t
	if t[1] == nil then 
		return true
	end	

	if t[1] == "rtv" then 
		if count == 1 and rockthevote then
			if rtv_initiated >= 0 then 
				local rtv_count = 0 
				local rtv_number = round(cur_players * rtv_required, 0)
				for i = 0,15 do
					if getplayer(i) then
						if rtv_table[gethash(i)] == 1 then 
							rtv_count = rtv_count + 1
						end
					end
				end
				if rtv_count == 0 then 
					rtv_initiated = 1 
					rtv_table[hash] = 1 
					rtv_count = rtv_count + 1 
					say(name .. " has initiated Rock-The-Vote (rtv) to skip this map!") 
					say("Type \"rtv\" to join the vote to skip this map.")
					rtvtimer = registertimer(120000, "rtvTimer")
				else
					if rtv_table[hash] == 1 then
						privatesay(player, "You have already voted for Rock-The-Vote.")
					elseif rtv_table[hash] == nil then 
						rtv_table[hash] = 1
						rtv_count = rtv_count + 1 
						say(name .. " has voted for Rock-The-Vote")
						say(rtv_count .. " of " .. rtv_number .. " votes required for Rock-The-Vote")
					end
				end
				if rtv_count >= rtv_number then
					removetimer(rtvtimer)
					rtvtimer = nil
					rtv_initiated = rtv_timeout
					say("Enough votes for Rock-The-Vote, skipping to next map.")
					svcmd("sv_map_next")
				end
			else
				privatesay(player, "You cannot initiate Rock-The-Vote at this time")
			end
			return false
		elseif count == 1 and not rockthevote then 
			privatesay(player, "Rock-The-Vote is disabled.")
			return false
		end
	end	
	
	return true
end

function rtvTimer(id, count)
	if count == 1 then
		rtv_initiated = rtv_timeout
		rtv_table = {}
		say("The current rtv has expired!")
		return false
	else
		return true
	end
end

function round(num)
    under = math.floor(num)
    upper = math.floor(num) + 1
    underV = -(under - num)
    upperV = upper - num
    if (upperV > underV) then
        return under
    else
        return upper
    end
end

-- Thanks to H® BugZ, Oxide, Elite Prime, Nugget & Wizard & many others for their contributions to Phasor and the Halo Community, Special Thanks to Elite Prime for added assistance.